﻿Module BindingSourceExtensions
    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="Source">Copy row from</param>
    ''' <param name="Target">Copy row too</param>
    ''' <param name="KeyField">Primary key exists in both sources</param>
    ''' <param name="Reposition">Move to row rather than copy if already exists in target</param>
    ''' <param name="CloneColumns">Clone source schema in target</param>
    ''' <remarks></remarks>
    <System.Runtime.CompilerServices.Extension()> _
    Public Sub CloneCurrentRow(
        ByVal Source As BindingSource,
        ByVal Target As BindingSource,
        ByVal KeyField As String,
        ByVal Reposition As Boolean,
        ByVal CloneColumns As Boolean)

        If Source.IsExistingRow Then
            If CloneColumns Then
                If Target.DataTable.Columns.Count <> Source.DataTable.Columns.Count Then
                    Target.DataSource = Source.DataTable.Clone
                End If
            End If
        End If

        If IsDataRow(Source) Then
            Dim Position As Integer = Target.Find(KeyField, Source.CurrentRow(KeyField))
            If Position = -1 Then
                Target.DataTable.ImportRow(Source.CurrentRow)
            Else
                If Reposition Then
                    Target.Position = Position
                End If
            End If
        End If

    End Sub
    <System.Diagnostics.DebuggerStepThrough()> _
    <System.Runtime.CompilerServices.Extension()> _
    Public Function GetIdentifier(ByVal sender As BindingSource, ByVal ColumnName As String) As String
        Dim Value As String = ""
        Value = CType(sender.Current, DataRowView).Item(ColumnName).ToString()
        Return Value
    End Function
    <System.Diagnostics.DebuggerStepThrough()> _
    <System.Runtime.CompilerServices.Extension()> _
    Public Function IsNewRow(ByVal sender As BindingSource) As Boolean
        Return sender.CurrentRow.RowState = DataRowState.Detached
    End Function
    <System.Diagnostics.DebuggerStepThrough()> _
    <System.Runtime.CompilerServices.Extension()> _
    Public Function IsExistingRow(ByVal sender As BindingSource) As Boolean
        If IsDataRow(sender) Then
            Return sender.CurrentRow.RowState <> DataRowState.Detached
        End If
    End Function
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Function IsDataRow(ByVal sender As BindingSource) As Boolean
        If TypeOf sender.Current Is DataRowView Then
            Return True
        Else
            Return False
        End If
    End Function
    <System.Diagnostics.DebuggerStepThrough()> _
    <System.Runtime.CompilerServices.Extension()> _
    Public Function DataTable(ByVal sender As BindingSource) As DataTable
        Return DirectCast(sender.DataSource, DataTable)
    End Function
    <System.Diagnostics.DebuggerStepThrough()> _
    <System.Runtime.CompilerServices.Extension()> _
    Public Function CurrentRow(ByVal sender As BindingSource) As DataRow
        Return DirectCast(sender.Current, DataRowView).Row
    End Function
    <System.Diagnostics.DebuggerStepThrough()> _
    <System.Runtime.CompilerServices.Extension()> _
    Public Function CurrentRow(ByVal sender As BindingSource, ByVal Column As String) As String
        Return DirectCast(sender.Current, DataRowView).Row(Column).ToString
    End Function
End Module
